MODULE Windows;

IMPORT
  SYSTEM, Kernel;

CONST
  NULL*                                     = 0;

  STD_INPUT_HANDLE*                         = -10;
  STD_OUTPUT_HANDLE*                        = -11;
  STD_ERROR_HANDLE*                         = -12;

  MAX_PATH*                                 = 260 (* {2, 8} *);

  IGNORE*                                   =  0 ;
  INFINITE*                                 =  -1 ;

  WAIT_FAILED*                              =  -1 ;
  WAIT_OBJECT_0*                            =  0 ;
  WAIT_ABANDONED*                           =  128 ;
  WAIT_ABANDONED_0*                         =  128 ;
  WAIT_TIMEOUT*                             =  258 ;
  WAIT_IO_COMPLETION*                       =  192 ;

  VK_LBUTTON*                               =  1 ;
  VK_RBUTTON*                               =  2 ;
  VK_CANCEL*                                =  3 ;
  VK_MBUTTON*                               =  4 ;
  VK_BACK*                                  =  8 ;
  VK_TAB*                                   =  9 ;
  VK_CLEAR*                                 =  12 ;
  VK_RETURN*                                =  13 ;
  VK_SHIFT*                                 =  16 ;
  VK_CONTROL*                               =  17 ;
  VK_MENU*                                  =  18 ;
  VK_PAUSE*                                 =  19 ;
  VK_CAPITAL*                               =  20 ;
  VK_ESCAPE*                                =  27 ;
  VK_SPACE*                                 =  32 ;
  VK_PRIOR*                                 =  33 ;
  VK_NEXT*                                  =  34 ;
  VK_END*                                   =  35 ;
  VK_HOME*                                  =  36 ;
  VK_LEFT*                                  =  37 ;
  VK_UP*                                    =  38 ;
  VK_RIGHT*                                 =  39 ;
  VK_DOWN*                                  =  40 ;
  VK_SELECT*                                =  41 ;
  VK_PRINT*                                 =  42 ;
  VK_EXECUTE*                               =  43 ;
  VK_SNAPSHOT*                              =  44 ;
  VK_INSERT*                                =  45 ;
  VK_DELETE*                                =  46 ;
  VK_HELP*                                  =  47 ;
  VK_LWIN*                                  =  91 ;
  VK_RWIN*                                  =  92 ;
  VK_APPS*                                  =  93 ;
  VK_NUMPAD0*                               =  96 ;
  VK_NUMPAD1*                               =  97 ;
  VK_NUMPAD2*                               =  98 ;
  VK_NUMPAD3*                               =  99 ;
  VK_NUMPAD4*                               =  100 ;
  VK_NUMPAD5*                               =  101 ;
  VK_NUMPAD6*                               =  102 ;
  VK_NUMPAD7*                               =  103 ;
  VK_NUMPAD8*                               =  104 ;
  VK_NUMPAD9*                               =  105 ;
  VK_MULTIPLY*                              =  106 ;
  VK_ADD*                                   =  107 ;
  VK_SEPARATOR*                             =  108 ;
  VK_SUBTRACT*                              =  109 ;
  VK_DECIMAL*                               =  110 ;
  VK_DIVIDE*                                =  111 ;
  VK_F1*                                    =  112 ;
  VK_F2*                                    =  113 ;
  VK_F3*                                    =  114 ;
  VK_F4*                                    =  115 ;
  VK_F5*                                    =  116 ;
  VK_F6*                                    =  117 ;
  VK_F7*                                    =  118 ;
  VK_F8*                                    =  119 ;
  VK_F9*                                    =  120 ;
  VK_F10*                                   =  121 ;
  VK_F11*                                   =  122 ;
  VK_F12*                                   =  123 ;
  VK_F13*                                   =  124 ;
  VK_F14*                                   =  125 ;
  VK_F15*                                   =  126 ;
  VK_F16*                                   =  127 ;
  VK_F17*                                   =  128 ;
  VK_F18*                                   =  129 ;
  VK_F19*                                   =  130 ;
  VK_F20*                                   =  131 ;
  VK_F21*                                   =  132 ;
  VK_F22*                                   =  133 ;
  VK_F23*                                   =  134 ;
  VK_F24*                                   =  135 ;
  VK_NUMLOCK*                               =  144 ;
  VK_SCROLL*                                =  145 ;
  VK_LSHIFT*                                =  160 ;
  VK_RSHIFT*                                =  161 ;
  VK_LCONTROL*                              =  162 ;
  VK_RCONTROL*                              =  163 ;
  VK_LMENU*                                 =  164 ;
  VK_RMENU*                                 =  165 ;
  VK_PROCESSKEY*                            =  229 ;
  VK_ATTN*                                  =  246 ;
  VK_CRSEL*                                 =  247 ;
  VK_EXSEL*                                 =  248 ;
  VK_EREOF*                                 =  249 ;
  VK_PLAY*                                  =  250 ;
  VK_ZOOM*                                  =  251 ;
  VK_NONAME*                                =  252 ;
  VK_PA1*                                   =  253 ;
  VK_OEM_CLEAR*                             =  254 ;

  KEY_EVENT*                                =  1;
  MOUSE_EVENT*                              =  2 ;
  WINDOW_BUFFER_SIZE_EVENT*                 =  4 ;
  MENU_EVENT*                               =  8 ;
  FOCUS_EVENT*                              =  16 ;
  
  FROM_LEFT_1ST_BUTTON_PRESSED*             =  {0};
  RIGHTMOST_BUTTON_PRESSED*                 =  {1};
  FROM_LEFT_2ND_BUTTON_PRESSED*             =  {2};
  FROM_LEFT_3RD_BUTTON_PRESSED*             =  {3};
  FROM_LEFT_4TH_BUTTON_PRESSED*             =  {4};
  
  MOUSE_MOVED*                              =  {0};
  DOUBLE_CLICK*                             =  {1};
      
TYPE
  BOOL*                                     = LONGINT;
  ADDRESS*                                  = LONGINT;
  ATOM*                                     = INTEGER;
  HANDLE*                                   = ADDRESS;
  HMODULE*                                  = ADDRESS;
  HINSTANCE*                                = ADDRESS;
  HGLOBAL*                                  = HANDLE;
  LPSTR*                                    = ADDRESS;
  HWND*                                     = HANDLE;

  UINT*                                     = LONGINT;
  MCIERROR*                                 = LONGINT;
  
  COORD*                                    = RECORD [NOTAG]
    X*: INTEGER;
    Y*: INTEGER;
  END;

  RECT* = RECORD [NOTAG]
    left*         : LONGINT;
    top*          : LONGINT;
    right*        : LONGINT;
    bottom*       : LONGINT;
  END;
  
  SMALL_RECT*                               =  RECORD [NOTAG]
    left*         : INTEGER;
    top*          : INTEGER;
    right*        : INTEGER;
    bottom*       : INTEGER;
  END;

  CHAR_INFO*                                =  RECORD [NOTAG]
    Char*         : CHAR;
    Attributes*   : INTEGER;
  END;

  CONSOLE_SCREEN_BUFFER_INFO*               =  RECORD [NOTAG]
    dwSize*          : COORD;
    dwCursorPosition*: COORD;
    wAttributes*: INTEGER;
    srWindow*: SMALL_RECT;
    dwMaximumWindowSize*: COORD;
  END;

  CONSOLE_CURSOR_INFO*                      =  RECORD [NOTAG]
    dwSize*: LONGINT;
    bVisible*: BOOL;
  END;

  HANDLER_ROUTINE*                          =  PROCEDURE (CtrlType: LONGINT): BOOL;

  KEY_EVENT_RECORD*                         =  RECORD [NOTAG]
    bKeyDown*: BOOL;
    wRepeatCount*: INTEGER;
    wVirtualKeyCode*: INTEGER;
    wVirtualScanCode*: INTEGER;
    (*uChar* : RECORD [NOTAG] *)
      UnicodeChar*: CHAR;
      AsciiChar*  : CHAR;
    (*END; *)
    dwControlKeyState*: SET;
  END;
  PtrKEY_EVENT_RECORD*                      =  POINTER TO KEY_EVENT_RECORD;

  MOUSE_EVENT_RECORD*                       =  RECORD [NOTAG]
    dwMousePosition*: COORD;
    dwButtonState*: SET;
    dwControlKeyState*: SET;
    dwEventFlags*: SET;
  END;
  PtrMOUSE_EVENT_RECORD*                    =  POINTER TO MOUSE_EVENT_RECORD;

  WINDOW_BUFFER_SIZE_RECORD*                =  RECORD [NOTAG]
    dwSize*: COORD;
  END;
  PtrWINDOW_BUFFER_SIZE_RECORD*             =  POINTER TO WINDOW_BUFFER_SIZE_RECORD;

  MENU_EVENT_RECORD*                        =  RECORD [NOTAG]
    dwCommandId*: LONGINT;
  END;
  PtrMENU_EVENT_RECORD*                     =  POINTER TO MENU_EVENT_RECORD;

  FOCUS_EVENT_RECORD*                       =  RECORD [NOTAG]
    bSetFocus*: BOOL;
  END;

  INPUT_RECORD*                             =  RECORD [NOTAG]
    EventType*: INTEGER;
    Event*: RECORD [NOTAG]
      KeyEvent*              : KEY_EVENT_RECORD;
      MouseEvent*            : MOUSE_EVENT_RECORD;
      WindowBufferSizeEvent* : WINDOW_BUFFER_SIZE_RECORD;
      MenuEvent*             : MENU_EVENT_RECORD;
      FocusEvent*            : FOCUS_EVENT_RECORD;
    END;
  END;

  INPUT_RECORD_X*                           =  RECORD [NOTAG]
    EventType*: INTEGER;
    Event*: RECORD [NOTAG]
      Data*: ARRAY 32 OF CHAR;
    END;
  END;
  
VAR
  AllocConsole-                 : PROCEDURE [WINAPI] (): BOOL;
  GetStdHandle-                 : PROCEDURE [WINAPI] (nStdHandle: LONGINT): HANDLE;
  SetStdHandle-                 : PROCEDURE [WINAPI] (nStdHandle: LONGINT; hHandle: HANDLE): BOOL;
  WriteFile-                    : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToWrite: LONGINT; VAR lpNumberOfBytesWritten: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;
  ReadFile-                     : PROCEDURE [WINAPI] (hFile: HANDLE; VAR lpBuffer: ARRAY [NOTAG] OF SYSTEM.BYTE; nNumberOfBytesToRead: LONGINT; VAR lpNumberOfBytesRead: LONGINT; lpOverlapped: SYSTEM.PTR): BOOL;

  SetConsoleCursorPosition-     : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; dwCursorPosition: LONGINT): BOOL;
  SetConsoleTitle-              : PROCEDURE [WINAPI] (lpConsoleTitle: ARRAY [NOTAG] OF CHAR): BOOL;
  SetConsoleTextAttribute-      : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; wAttributes: INTEGER): BOOL;
  FillConsoleOutputCharacter-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; cCharacter: CHAR; nLength: LONGINT; dwWriteCoord: LONGINT; VAR lpNumberOfCharsWritten: LONGINT): BOOL;
  FillConsoleOutputAttribute-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; wAttribute: INTEGER; nLength: LONGINT; dwWriteCoord: LONGINT; VAR lpNumberOfAttrsWritten: LONGINT): BOOL;
  GetLargestConsoleWindowSize-  : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE): INTEGER;
  GetConsoleScreenBufferInfo-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleScreenBufferInfo: CONSOLE_SCREEN_BUFFER_INFO): BOOL;
  SetConsoleScreenBufferSize-   : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; dwSize: LONGINT): BOOL;
  ScrollConsoleScreenBuffer-    : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpScrollRectangle: SMALL_RECT; VAR lpClipRectangle: SMALL_RECT; dwDestinationOrigin: LONGINT; VAR lpFill: CHAR_INFO): BOOL;
  GetConsoleCursorInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleCursorInfo: CONSOLE_CURSOR_INFO): BOOL;
  SetConsoleCursorInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; VAR lpConsoleCursorInfo: CONSOLE_CURSOR_INFO): BOOL;
  SetConsoleWindowInfo-         : PROCEDURE [WINAPI] (hConsoleOutput: HANDLE; bAbsolute: BOOL; VAR lpConsoleWindow: SMALL_RECT): BOOL;
  WaitForSingleObjectEx-        : PROCEDURE [WINAPI] (hHandle: HANDLE; dwMilliseconds: LONGINT; bAlertable: BOOL): LONGINT;
  ReadConsoleInput-             : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpBuffer: INPUT_RECORD; nLength: LONGINT; VAR lpNumberOfEventsRead: LONGINT): BOOL;
  ReadConsoleInputX-            : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpBuffer: INPUT_RECORD_X; nLength: LONGINT; VAR lpNumberOfEventsRead: LONGINT): BOOL;

  GetNumberOfConsoleInputEvents- : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; VAR lpNumberOfEvents: LONGINT): BOOL;
  
  mciSendString-                : PROCEDURE [WINAPI] (lpstrCommand: ARRAY [NOTAG] OF CHAR; VAR lpstrReturnString: LPSTR; uReturnLength: UINT; hWndCallback: HWND): MCIERROR;

  SetConsoleFont-               : PROCEDURE [WINAPI] (hConsoleInput: HANDLE; NumberFont: LONGINT):BOOL;
  
PROCEDURE Shutdown* ();
BEGIN
  Kernel.Shutdown(0);
END Shutdown;

BEGIN
  IF Kernel.call = 0 THEN
    INC(Kernel.call);
    Kernel.Init();
  ELSIF Kernel.ExitProc # NIL THEN
    Kernel.Shutdown(0);
  END;
END Windows.
